<?php

if(!isset($argv[1]))
{
   echo "Input file name required.\n";
   exit;
}

if(!is_file($argv[1]))
{
   echo 'Input file not found.'."\n";
   exit;
}

$colortransform = '_changegrayt';
//$colortransfrom = 'same';
$imagewidth = 300;
$filename = $argv[1];

$palette_height_boxes = 5;
$palette_box_dim = 12;
$palette_width_boxes = 12;



function _changegrayt($colorhex)
{
   $colorcode = hexdec($colorhex);
   
   if($colorcode == 0)
   { return '000000'; }
   
   $red = ($colorcode >> 16) & 255;
   $green = ($colorcode >> 8) & 255;
   $blue = $colorcode & 255;
   
   $max = 0;
   if($red > $max) $max = $red;
   if($green > $max) $max = $green;
   if($blue > $max) $max = $blue;
   
   if($max < 30)
   {
      return '000000';
   }
   
   return 'FFFFFF';
}


function _changegraym($colorhex)
{
   $colorcode = hexdec($colorhex);
   
   if($colorcode == 0)
   { return '000000'; }
   
   $red = ($colorcode >> 16) & 255;
   $green = ($colorcode >> 8) & 255;
   $blue = $colorcode & 255;
   
   $max = 0;
   if($red > $max) $max = $red;
   if($green > $max) $max = $green;
   if($blue > $max) $max = $blue;
   
   if($max < 30)
   {
      return '000000';
   }
   
   $newchannels = $max;
   
//   $newchannels = floor( ($red + $green + $blue) / 3);
   if($newchannels > 255)
   {
      $newchannels = 255;
   }
   
   
   //if($newchannels < 80)
   //{
   //   $newchannels += 90;
   //}
   
   
   $newchannels = (int)$newchannels;
   //var_dump($newchannels);
   
   return dechex( ($newchannels << 16) + ($newchannels << 8) + $newchannels);
}


function _changegrayb($colorhex)
{
   $colorcode = hexdec($colorhex);
   
   if($colorcode == 0)
   { return '000000'; }
   
   $red = ($colorcode >> 16) & 255;
   $green = ($colorcode >> 8) & 255;
   $blue = $colorcode & 255;
   
   $max = 0;
   if($red > $max) $max = $red;
   if($green > $max) $max = $green;
   if($blue > $max) $max = $blue;
   
   if($max < 30)
   {
      return '000000';
   }
   
   $newchannels = floor( ($red + $green + $blue) / 3);
   if($newchannels > 255)
   {
      $newchannels = 255;
   }
   
   
   //if($newchannels < 80)
   //{
   //   $newchannels += 90;
   //}
   
   
   $newchannels = (int)$newchannels;
   //var_dump($newchannels);
   
   return dechex( ($newchannels << 16) + ($newchannels << 8) + $newchannels);
}

function same($colorhex)
{
   return $colorhex;
}


ob_start();
?>
import flash.geom.ColorTransform;
import flash.geom.Transform;

class Tuto {


/////////////////////////////////////////////////////////////////////////
//
// Bezier_lib.as - v1.2 - 19/05/02
// Timothee Groleau
//
// The purpose of this file is mainly to provide a function drawCubicBezier
// for the MovieClip prototype to approximate a cubic Bezier curve
// from the quadratic curveTo of the Flash drawing API
//
// By doing so, several useful functions are created to calculate cubic
// bezier points and derivative. Other Bezier functions can be added to
// the _global.Bezier object, like quadratic or quartic function as necessary.
//
// Also a few functions are added to the Math object to handle 2D line equations
//
/////////////////////////////////////////////////////////////////////////
	
	
	// Gets a line equation as two properties (a,b) such that (y = a*x + b) for any x
	// or a unique c property such that (x = c) for all y
	// The function takes two points as parameter, P0 and P1 containing two properties x and y

	
	static function getLine (P0, P1) {
	var l = {};
	var x0 = P0.x;
	var y0 = P0.y;
	var x1 = P1.x;
	var y1 = P1.y;
	
	if (x0 == x1) {
		if (y0 == y1) {
			// P0 and P1 are same point, return null
			l = null;
		} else {
			// Otherwise, the line is a vertical line
			l.c = x0;
		}
	} else {
		l.a = (y0 - y1) / (x0 - x1);
		l.b = y0 - (l.a * x0);
	}
	
	// returns the line object
	return l;
	}
	
	

	// return the middle of a segment define by two points
	static function getMiddle (P0, P1) {
		return {x: ((P0.x + P1.x) / 2), y: ((P0.y + P1.y) / 2)};
	}


	// return a point on a segment [P0, P1] which distance from P0
	// is ratio of the length [P0, P1]
	static function getPointOnSegment (P0, P1, ratio) {
		return {x: (P0.x + ((P1.x - P0.x) * ratio)), y: (P0.y + ((P1.y - P0.y) * ratio))};
	}	
	

	// This function will trace a cubic approximation of the cubic Bezier
	// It will calculate a serie of [control point/Destination point] which 
	// will be used to draw quadratic Bezier starting from P0
	static function drawCubicBezier2 (mc, P0, P1, P2, P3) {

		// calculates the useful base points
		var PA = Tuto.getPointOnSegment(P0, P1, 3/4);
		var PB = Tuto.getPointOnSegment(P3, P2, 3/4);
	
		// get 1/16 of the [P3, P0] segment
		var dx = (P3.x - P0.x)/16;
		var dy = (P3.y - P0.y)/16;
		
		// calculates control point 1
		var Pc_1 = Tuto.getPointOnSegment(P0, P1, 3/8);
		
		// calculates control point 2
		var Pc_2 = Tuto.getPointOnSegment(PA, PB, 3/8);
		Pc_2.x -= dx;
		Pc_2.y -= dy;
	
		// calculates control point 3
		var Pc_3 = Tuto.getPointOnSegment(PB, PA, 3/8);
		Pc_3.x += dx;
		Pc_3.y += dy;
	
		// calculates control point 4
		var Pc_4 = Tuto.getPointOnSegment(P3, P2, 3/8);
		
		// calculates the 3 anchor points
		var Pa_1 = Tuto.getMiddle(Pc_1, Pc_2);
		var Pa_2 = Tuto.getMiddle(PA, PB);
		var Pa_3 = Tuto.getMiddle(Pc_3, Pc_4);

		// draw the four quadratic subsegments
		mc.curveTo(Pc_1.x, Pc_1.y, Pa_1.x, Pa_1.y);
		mc.curveTo(Pc_2.x, Pc_2.y, Pa_2.x, Pa_2.y);
		mc.curveTo(Pc_3.x, Pc_3.y, Pa_3.x, Pa_3.y);
		mc.curveTo(Pc_4.x, Pc_4.y, P3.x, P3.y);
	}

	static var app : Tuto;

        static function pal_click(r, g, b)
        {
           return function() { _root.red = r; _root.green = g; _root.blue = b; 
             if(_root.palette.indi != undefined)
             {
                _root.palette.indi.drawupdate();
             }
           
           }
        }


        static function hsv_to_rgb( h, s, v ) {
	// H is given on [0, 6] or UNDEFINED. S and V are given on [0, 1].
	// RGB are each returned on [0, 1].
	var m:Number, n:Number, f:Number;
	var i:Number;
	
	//if (h == 0) RETURN_RGB(v, v, v);
	i = Math.floor(h);
	f = h - i;
	if ( !(i&1) ) f = 1 - f; // if i is even
	m = v * (1 - s);
	n = v * (1 - s * f);
	switch (i) {
		case 6:
		case 0: return [v, n, m];
		case 1: return [n, v, m];
		case 2: return [m, v, n];
		case 3: return [m, n, v];
		case 4: return [n, m, v];
		case 5: return [v, m, n];
	   }

	} 


	// entry point
	static function main(mc) {
		app = new Tuto();
	}

        function Tuto() {
        
          _root.red = 0xFF;
          _root.blue = 0xFF;
          _root.green = 0x80;
          
          
          /* Draw the palette */
          
          var x:Number = 0;
          var y:Number = 0;
          var q:Number = 0;
          
          var top:Number = 0;
          
          var r:Number = 0;
          var g:Number = 0;
          var b:Number = 0;
          var c:Number = 0;
          
          _root.createEmptyMovieClip('palette', 3);
          _root.palette._x = 0;
          _root.palette._y = 150;
          
          
          _root.palette.draw = function(z:Number)
          {

             var bs:Number = <?php echo $palette_box_dim; ?>;
             var bbs:Number = bs-1;
             var xc:Number = <?php echo $palette_width_boxes-2;?>; //Number of blocks along the x axis.
             var yc:Number = <?php echo $palette_height_boxes-1; ?>; //Number of blocks along the y axis.
             var rgb:Array;
          
             /*Draw indicator block.*/
             
             
                   c = (yc*xc)+x+400;
                   this.createEmptyMovieClip('indi', c);
                
                   this['indi'].drawupdate = function()
                   {
                      x = xc+2;
                   
                      r = _root.red;
                      g = _root.green;
                      b = _root.blue;
                   
                      this.beginFill((r << 16) + (g << 8) + b, 100);
                      this.moveTo((x-1)*bs, 0);
                      this.lineTo(((x-1)*bs)+bs, 0);
                      this.lineTo(((x-1)*bs)+bs, yc*bs);
                      this.lineTo((x-1)*bs, (yc*bs));
                      this.endFill();                   
                   }

                   
                   this['indi'].drawupdate();
                

                   
                                   
          
          
             for(x = 1; x <= xc; x++)
             {
                for(y = 0; y < yc; y++)
                {
                   rgb = Tuto.hsv_to_rgb( (6/xc) * (x-1), 1- ((1/yc) * y), z);
             
                   r = Math.floor(rgb[0] * 255);
                   g = Math.floor(rgb[1] * 255);
                   b = Math.floor(rgb[2] * 255);
             
                   //b = Math.floor(x * (0xFF / xc));
                   //g = Math.floor((xc-x) * (0xFF / xc));
                   //r = Math.floor(y * (0xFF / yc));
                   c = (y*xc)+x;
                   _root.palette.createEmptyMovieClip('color'+c, c);
                   _root.palette['color'+c].lineStyle(1, 0);
                
                   _root.palette['color'+c].beginFill((r << 16) + (g << 8) + b, 100);
                   _root.palette['color'+c].moveTo((x-1)*bs, y*bs);
                   _root.palette['color'+c].lineTo(((x-1)*bs)+bbs, y*bs);
                   _root.palette['color'+c].lineTo(((x-1)*bs)+bbs, (y*bs)+bbs);
                   _root.palette['color'+c].lineTo((x-1)*bs, (y*bs)+bbs);
                   _root.palette['color'+c].endFill();
                
                   _root.palette['color'+c].onRelease = Tuto.pal_click(r, g, b);                
               }
             }
             
             //Draw the white block.
             y = 0;
             x = xc+1
             c = (yc*xc)+x+1;
             
             this.createEmptyMovieClip('color'+c, c);
             this['color'+c].lineStyle(1, 0);
             
             r = g = b = Math.floor(255 * z);
             
             this['color'+c].beginFill((r << 16) + (g << 8) + b, 100);
             this['color'+c].moveTo((x-1)*bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bbs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bbs, (y*bs)+bbs);
             this['color'+c].lineTo((x-1)*bs, (y*bs)+bbs);
             this['color'+c].endFill();
                
             this['color'+c].onRelease = Tuto.pal_click(r, g, b);                

             //Draw the black block
             y = yc -1;
             x = xc+1
             c = (yc*xc)+x+2;
             
             this.createEmptyMovieClip('color'+c, c);
             this['color'+c].lineStyle(1, 0);
             
             r = g = b = 0;
             
             this['color'+c].beginFill((r << 16) + (g << 8) + b, 100);
             this['color'+c].moveTo((x-1)*bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bbs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bbs, (y*bs)+bbs);
             this['color'+c].lineTo((x-1)*bs, (y*bs)+bbs);
             this['color'+c].endFill();
                
             this['color'+c].onRelease = Tuto.pal_click(r, g, b);    
             
             //Now (re)create the V-level control buttons

             y = yc -3;
             x = xc+1
             c = (yc*xc)+x+3;
             
             this.createEmptyMovieClip('color'+c, c);
             
             r = g = b = 255;
             
             
             
             this['color'+c].beginFill((r << 16) + (g << 8) + b, 100);
             this['color'+c].moveTo((x-1)*bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bs, (y*bs)+bs);
             this['color'+c].lineTo((x-1)*bs, (y*bs)+bs);
             this['color'+c].endFill();
             
             this['color'+c].lineStyle(1, 0xFFCCFF);
             
             this['color'+c].beginFill(0, 100);
             this['color'+c].moveTo((x-1)*bs+(bs/2), y*bs);
             this['color'+c].lineTo();
             this['color'+c].lineTo(((x-1)*bs)+bbs, (y*bs)+bbs);
             this['color'+c].lineTo((x-1)*bs, (y*bs)+bbs);
             this['color'+c].endFill();
             
             this['color'+c].onRelease = function() {
                _root.palette.draw( (z + 0.2) > 1 ? 1 : z + 0.2 );
             } 



             y = yc -2;
             x = xc+1
             c = (yc*xc)+x+4;
             
             this.createEmptyMovieClip('color'+c, c);
             
             r = g = b = 255;
             
             
             
             this['color'+c].beginFill((r << 16) + (g << 8) + b, 100);
             this['color'+c].moveTo((x-1)*bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bs, y*bs);
             this['color'+c].lineTo(((x-1)*bs)+bs, (y*bs)+bs);
             this['color'+c].lineTo((x-1)*bs, (y*bs)+bs);
             this['color'+c].endFill();
             
             this['color'+c].lineStyle(1, 0xFFCCFF);
             
             this['color'+c].beginFill(0, 100);
             this['color'+c].moveTo((x-1)*bs+(bs/2), y*bs+bbs);
             this['color'+c].lineTo(((x-1)*bs)+bbs, (y*bs));
             this['color'+c].lineTo((x-1)*bs, (y*bs));
             this['color'+c].endFill();
             
             this['color'+c].onRelease = function() {
                _root.palette.draw( (z - 0.2) < 0.2 ? 0.2 : z - 0.2 );
             } 

             //Draw the used-colors palette:
             
             if(this.usedcolors != undefined)
             {
                for(q = 0; q < xc+1; q++)
                {
                   if(this.usedcolors[q] != undefined)
                   {
                      c = 150+q;
                      _root.palette.createEmptyMovieClip('color'+c, c);
                      _root.palette['color'+c].lineStyle(1, 0);
                
                      _root.palette['color'+c].beginFill(this.usedcolors[q], 100);
                      _root.palette['color'+c].moveTo((q)*bs, yc*bs);
                      _root.palette['color'+c].lineTo(((q)*bs)+bbs, yc*bs);
                      _root.palette['color'+c].lineTo(((q)*bs)+bbs, (yc*bs)+bbs);
                      _root.palette['color'+c].lineTo((q)*bs, (yc*bs)+bbs);
                      _root.palette['color'+c].endFill();     
                      
                      r = (this.usedcolors[q] & 0xFF0000) >> 16;
                      g = (this.usedcolors[q] & 0x00FF00) >> 8;
                      b = (this.usedcolors[q] & 0x0000FF);
                      
                      _root.palette['color'+c].onRelease = Tuto.pal_click(r, g, b);                 
                   }
                }
             }
             
             x = xc+1;
             y = yc;
             c = 190;

                      _root.palette.createEmptyMovieClip('printer', c);
                      //_root.palette['printer'].lineStyle(0, 0);
                
                      _root.palette['printer'].beginFill(0xFFFFFF, 100);
                      _root.palette['printer'].moveTo((q)*bs, yc*bs);
                      _root.palette['printer'].lineTo(((q)*bs)+bbs, yc*bs);
                      _root.palette['printer'].lineTo(((q)*bs)+bbs, (yc*bs)+bbs);
                      _root.palette['printer'].lineTo((q)*bs, (yc*bs)+bbs);
                      _root.palette['printer'].endFill();
                      
                      this['printer'].createEmptyMovieClip('icon', 2);
                      this.printer.icon._x = (q)*bs;
                      this.printer.icon._y = yc*bs;
                      
                      this.printer.icon.lineStyle(1, 0);
                      this.printer.icon.beginFill(0xCCCCCC, 100);
                      this.printer.icon.moveTo(2, 5);
                      this.printer.icon.lineTo(10, 5);
                      this.printer.icon.lineTo(10, 10);
                      this.printer.icon.lineTo(9,11);
                      this.printer.icon.lineTo(3,11);
                      this.printer.icon.lineTo(2,10);
                      this.printer.icon.endFill();
                      
                      this.printer.icon.beginFill(0xFFFFFF, 100);
                      this.printer.icon.moveTo(4, 2);
                      this.printer.icon.lineTo(8,2);
                      this.printer.icon.lineTo(8,7);
                      this.printer.icon.lineTo(4,7);
                      this.printer.icon.endFill();
                      
                      //this.printer.icon.moveTo(4.5,4);
                      //this.printer.icon.lineTo(7.5,4);
                      
                      //this.printer.icon.moveTo(4.5,5.5);
                      //this.printer.icon.lineTo(7.5, 5.5);
             
             _root.palette['printer'].onRelease = function() { print(_root.colorcontainer, "bmax"); } ;
             //print();
             
          }
          
          _root.palette.draw(1);
          

          
          
<?php
$tutoheader = ob_get_clean();



$tutofooter = '}}';




class command {
   var $action; /* String */
   var $points; /* Array of Arrays. */
   
   function command($command_letter, $points)
   {
      $this->action = $command_letter;
      $this->points = $points;
   }
   
   function render($groupname)
   {  
      echo "         ";
      switch($this->action)
      {
         case 'L':
            echo "_root.colorcontainer.{$groupname}.lineTo({$this->points[0][0]}, {$this->points[0][1]});\n";
            break;
         case 'M';
            echo "_root.colorcontainer.{$groupname}.moveTo({$this->points[0][0]}, {$this->points[0][1]});\n";
            break;
         case 'C':
            $current = $this->_point($this->points[3]);
            $target = $this->_point($this->points[0]);
            $cp1 = $this->_point($this->points[1]);
            $cp2 = $this->_point($this->points[2]);
            echo "Tuto.drawCubicBezier2(_root.colorcontainer.{$groupname}, $current, $cp1, $cp2, $target );\n";
            break;
      }
   }
   
   function _point($point)
   {
      return "{ x: {$point[0]} , y: {$point[1]} }";
   }
}


function path_break($path, $pathid = 0)
{
   $regions = explode('M', $path);
   
   static $current;
   
   $com_groups;
   
   $points = array();
   
   $first = true;
   
   foreach($regions as $region)
   {
      if(trim($region) == '') continue;
      $command_group = array();
      $current = array(0,0);
      $tokens = explode(' ',trim($region));
      if(preg_match('/^[\d-\.]+/', trim($region)) == 1)
      {
         $point = explode(',', array_shift($tokens));        
         $command_group[] = new command('M', array($point));
         $current = $point;
         $points[] = $point;
         $first = false;
      }
      
      while(count($tokens) > 0)
      {
         $token = array_shift($tokens);
         
         
         
         switch($token)
         {
            case 'l';
               $point = explode(',', array_shift($tokens));
               $command_group[] = new command('L', array($current[0] = $point[0]+$current[0], $current[1] = $point[1]+$current[1]));
               $points[] = $current;
               $first = false;
               break;
            case 'L':
               $point = explode(',', array_shift($tokens));
               $command_group[] = new command('L', array($point));
               $current = $point;
               $points[] = $current;
               $first = false;
               break;
            case 'C':
               $cp1 = explode(',', array_shift($tokens));
               $cp2 = explode(',', array_shift($tokens));
               $point = explode(',', array_shift($tokens));
               $command_group[] = new command('C', array($point, $cp1, $cp2, $current));
               $current = $point;
               $points[] = $current;
               $first = false;
               break;
            case 'c':
               $cp1 = explode(',', array_shift($tokens));
               $cp2 = explode(',', array_shift($tokens));
               $point = explode(',', array_shift($tokens));
               $cp1 = array($cp1[0] + $current[0], $cp1[1] + $current[1]);
               $cp2 = array($cp2[0] + $current[0], $cp2[1] + $current[1]);
               $point = array($point[0] + $current[0], $point[1] + $current[1]);
               $command_group[] = new command('C', array($point, $cp1, $cp2, $current));
               $current = $point;
               $points[] = $current;
               $first = false;
               break;               
            case 'm':
               $point = explode(',', array_shift($tokens));
               if($first)
               {
                  $command_group[] = new command('M', array($point[0],  $point[1]));
               }
               else
               {
                  $command_group[] = new command('M', array($current[0] = $point[0]+$current[0], $current[1] = $point[1]+$current[1]));
               }
               $points[] = $current;
               $first = false;
               break;               
            case 'z':
               break;
            default:
               echo " /* Unrecognized token: {$token} - {$pathid} */ \n";
         }
      }

      if(count($command_group) > 0)
      {
         $com_groups[] = $command_group;
      }

   }
   
   return array($com_groups, $points);
}



function rectify_coordinates($comms, $points, $width = 150)
{
   /*Rectify command groups to be relative to 0 with width of 150*/
   $smallestx = 1999999;
   $smallesty = 1999999;
   
   $biggestx = -19999.01;
   $biggesty = -19999.01;
   
   foreach($points as $pt)
   {
      if(floatval($pt[0]) < $smallestx)
      {
         $smallestx = floatval($pt[0]);
      }
      
      if(floatval($pt[1]) < $smallesty)
      {
         $smallesty = floatval($pt[1]);
      }
      
      if(floatval($pt[0]) > $biggestx)
      {
         $biggestx = floatval($pt[0]);
      }
      
      if(floatval($pt[1]) > $biggesty)
      {
         $biggesty = floatval($pt[1]);
      }
   }
   
   $origwidth = $biggestx - $smallestx;
   $origheight = $biggesty - $smallesty;
   
   $ratio = $width / $origwidth;
   $offsetx = $smallestx * -1;
   $offsety = $smallesty * -1;
   
   //var_dump($ratio);
   
   
   
   $commsx = array();
   foreach($comms as $commset)
   {
      $proc_groups = array();
      foreach($commset['commands'] as $group)
      {
         $p = array();
         foreach($group as $com)
         {  
         
            for($i = 0; $i < count($com->points); $i++)
            {
               $com->points[$i] = array( round(($com->points[$i][0]-$smallestx)*$ratio, 3), round(($com->points[$i][1]-$smallesty)*$ratio, 3) );
            }
            $p[] = $com;
         }
         $proc_groups[] = $p;
      }
      $commsx[] = array('commands' => $proc_groups, 'color' => $commset['color']);
   }
   return array('corrected' => $commsx, 'width' => $width, 'height' => $origheight*$ratio);
}


function svg_to_coloring($svgdata, $imagewidth = 150)
{
   @mkdir('classes');
   
   $files = glob('classes/*.as');
   
   global $colortransform;
   
   foreach($files as $file) unlink($file);
   
   global $tutoheader, $tutofooter;
   $dom = new DOMDocument();
   $res = @$dom->loadXML($svgdata);
   $xpath = new DOMXPath($dom);
   //$paths = $dom->getElementsByTagName('path');

   $svg  = $dom->getElementsByTagName('svg')->item(0);
   
   $comms = array();
   $points = array();
   $count = 0;
   $usedcolors = array();
   
   foreach($svg->childNodes as $node)
   {
      switch($node->nodeName)
      {
         case 'g';
            $paths = $node->getElementsByTagName('path');
            $commands_set = array();
            foreach($paths as $path)
            {
               
               if(preg_match('/^fill\:/', $path->getAttribute('style')))
               {
                  $match = array();
                  preg_match('/fill\:\#([a-fA-F0-9]{3,6})/', $path->getAttribute('style'), $match);
               
                  //$hex = preg_replace('/[^a-fA-F0-9]/', '', array_pop(explode(':', $tmp = $path->getAttribute('style'))));
                  $hex = $match[1];
                  $d = $path->getAttribute('d');
         
         
                  list($commands, $pointsx) = path_break($d, $count);
                  $count++;
                  $color = $colortransform($hex);
                  
                  $usedcolors[hexdec($hex)] = (isset($usedcolors[hexdec($hex)])) ? $usedcolors[hexdec($hex)]+1 : 1;
                  
                  //var_dump($commands);
                  
                  //$comms[] = array('commands' => $commands, 'color' => $hex);
                  $commands_set = array_merge($commands_set, $commands);
                  $points = array_merge($points, $pointsx);
               }
            }
            //var_dump($commands_set);
            
            $new_commands_set = array();
            foreach($commands_set as $comset)
            {
               $new_commands_set = array_merge($new_commands_set, $comset);
            }
            
            
            $comms[] = array('commands' => array($new_commands_set), 'color' => $color);
            break;
         case 'path':
            $path = $node;
            if(preg_match('/^fill\:/', $path->getAttribute('style')))
            {
               
               
                  $match = array();
                  preg_match('/fill\:\#([a-fA-F0-9]{3,6})/', $path->getAttribute('style'), $match);
               
                  //$hex = preg_replace('/[^a-fA-F0-9]/', '', array_pop(explode(':', $tmp = $path->getAttribute('style'))));
                  $hex = $match[1];
                  
               $d = $path->getAttribute('d');
         
         
               list($commands, $pointsx) = path_break($d, $count);
               $count++;
               $comms[] = array('commands' => $commands, 'color' => $colortransform($hex));
               $usedcolors[hexdec($hex)] = (isset($usedcolors[hexdec($hex)])) ? $usedcolors[hexdec($hex)]+1 : 1;
               $points = array_merge($points, $pointsx);
            }
         break;
         
         
      }
   }
   
   $correct = rectify_coordinates($comms, $points, $imagewidth);

   //$correct['corrected'] = array_reverse($correct['corrected']);



   echo $tutoheader
   ?>
   _root.createEmptyMovieClip('colorcontainer', 1);

   _root.colorcontainer.beginFill(0xFFFFFF, 100);
   _root.colorcontainer.moveTo(0,0);
   _root.colorcontainer.lineTo(<?php echo ceil($correct['width']); ?>,0);
   _root.colorcontainer.lineTo(<?php echo ceil($correct['width']); ?>,<?php echo ceil($correct['height']); ?>);
   _root.colorcontainer.lineTo(0,<?php echo ceil($correct['height']); ?>);
   _root.colorcontainer.endFill();   
   
   _root.colorcontainer._width = <?php echo ceil($correct['width']); ?>;
   _root.colorcontainer._height = <?php echo ceil($correct['height']); ?>;
   
   
   <?php $GLOBALS['CHEIGHT'] = ceil($correct['height']); ?>
   
   <?php
   $level = 3;
   foreach($correct['corrected'] as $ckey => $color)
   {
      //var_dump(array_keys($color));
      foreach($color['commands'] as $gkey => $group)
      {
        $groupname = "m{$ckey}_{$gkey}";
        ob_start();
        ?>
        _root.colorcontainer.createEmptyMovieClip('<?php echo $groupname; ?>', <?php echo $level; ?>);
        <?php $level++; ?>
        _root.colorcontainer.<?php echo $groupname; ?>.beginFill(0x<?php echo $color['color']; ?>, 100);
         <?php
           foreach($group as $command)
           {
              //var_dump($command);
              $command->render($groupname);
           }   
         ?>    
         _root.colorcontainer.<?php echo $groupname; ?>.endFill();
         
         <?php if($color['color'] != "000000") : ?>
            _root.colorcontainer.<?php echo $groupname; ?>.onRelease = function() {
               var colorTrans = new flash.geom.ColorTransform();
               var transForm = new flash.geom.Transform(this);
               colorTrans.rgb = (_root.red << 16) + (_root.green << 8) + (_root.blue);
               transForm.colorTransform = colorTrans;
            }
         <?php else: ?>
            _root.colorcontainer.<?php echo $groupname; ?>.onRelease = function() { return true; }
         <?php endif; ?>
         
         <?php
        $chunk = "class {$groupname} { static function d() { ".ob_get_clean()." } } ";
        echo "\n    {$groupname}.d();   // {$color['color']}  \n";
        file_put_contents("classes/{$groupname}.as", $chunk);
      }
   }
   
   ?>
   
   _root.palette._y = _root.colorcontainer._height;
   
   <?php 
         if(isset($usedcolors[0])) unset($usedcolors[0]);
         if(isset($usedcolors[0xFFFFFF])) unset($usedcolors[0xFFFFFF]);
          
         arsort($usedcolors, SORT_NUMERIC);
         global $palette_width_boxes;    
         
         //var_dump($usedcolors);
         
         $u_palette = array_slice(array_keys($usedcolors), 0, $palette_width_boxes);
         
   ?>
   //asort($usedcolors, true);
   _root.palette.usedcolors = [ <?php echo implode(', ', $u_palette); ?>];
   
   _root.palette.draw(1);
   
   var ratio_p:Number = _root.colorcontainer._width / _root.palette._width;
   
   _root.palette._width *= ratio_p;
   _root.palette._height *= ratio_p;
   <?php
   
   echo $tutofooter;
}



ob_start();
svg_to_coloring(file_get_contents($filename), $imagewidth);
$precompiler_output = ob_get_clean();

$targetswf = escapeshellarg(basename($filename).'.swf');
$targetas = basename($filename).'.as';
$targetas_s = escapeshellarg($targetas);

file_put_contents($targetas, $precompiler_output);

$iwidth = intval(trim($imagewidth));

/*
$palette_height_boxes = 5;
$palette_box_dim = 12;
$palette_width_boxes = 11;
*/

$ratio_p = $imagewidth / ($palette_box_dim*$palette_width_boxes);



$iheight = ceil($GLOBALS['CHEIGHT'] + ($palette_box_dim*$palette_height_boxes*$ratio_p));
//echo ceil($GLOBALS['CHEIGHT']);

system($q = "mtasc -cp ./classes -header {$iwidth}:{$iheight}:12 $targetas_s -main -swf $targetswf -version 8");
echo $q;

